var ChartInt = function(id) {

    var chart = this;

    this.options = {

        pollID : null,
        chartTotals : null,
        display : null,
        chartType : null,
        chartOptionsCount : 0

    };


    function init(id){

        chart.options.pollID = id;


        loadPoll();

    }


    function loadPoll(){

        jQuery.post(ajaxurl, {action:"chart_data_chart", chart_id:chart.options.pollID}, function(response){

            var json = jQuery.parseJSON(response), totalVotes = 0;

            chart.options.chartType = json.chart_type;
            chart.options.chartOptionsCount = json.totals.length;
            //Make totals integers
            for (var i=0; i < json.totals.length; i++)
                json.totals[i] = parseFloat(json.totals[i]);


            if (json.chart_type == 1 || json.chart_type == 4 || json.chart_type == 5){

                var data = {

                    labels : json.labels,

                    datasets : [

                        {
                            fillColor : json.styles[0].fillColor,
                            strokeColor : json.styles[0].strokeColor,
                            pointColor : json.styles[0].pointColor,
                            pointStrokeColor : json.styles[0].pointStrokeColor,
                            data : json.totals

                        }
                    ]
                }

                for(var i = 0; i < data.datasets[0].data.length; i++)
                    totalVotes += data.datasets[0].data[i];

            }else {

                var data = [];

                for (var i = 0; i < json.totals.length; i++){

                    totalVotes += parseFloat(json.totals[i]);

                    data.push({
                        value: parseFloat(json.totals[i]),
                        color : json.option_colours[i],
                        label : json.labels[i]
                    });
                }


            }

                chart.options.chartTotals = json.totals;
                var override = overrideOptions();

                json.options = jQuery.extend({}, override, json.options);

            if (parseInt(json.maxWidth) == 0){

                //if (parseInt(json.chartType != 7)){
                    var width = jQuery("[data-chart-id='"+ chart.options.pollID +"'] #weblator-charts-chart-" + chart.options.pollID).parent().width();

                    jQuery("[data-chart-id='"+ chart.options.pollID +"'] #weblator-charts-chart-" + chart.options.pollID).attr({width: width});
                    jQuery("[data-chart-id='"+ chart.options.pollID +"'] #weblator-charts-chart-" + chart.options.pollID).attr({height: parseInt(width) / 2});

                if (parseInt(json.chartType) == 5 || parseInt(json.chartType)){
                    jQuery("[data-chart-id='"+ chart.options.pollID +"'] #weblator-charts-chart-" + chart.options.pollID).removeAttr("height");
                }

            }

                //var ctx = document.getElementById("weblator-charts-chart-" + chart.options.pollID).getContext("2d");

                jQuery("[data-chart-id='"+ chart.options.pollID +"'] #weblator-charts-chart-" + chart.options.pollID).slideDown(function(){


                    switch(parseInt(json.chart_type)){

                        case 1:

                            chart.options.display = new Chart( document.getElementById("weblator-charts-chart-" + chart.options.pollID).getContext("2d") ).Bar(data, json.options);
                            break;

                        case 2:

                            chart.options.display = new Chart( document.getElementById("weblator-charts-chart-" + chart.options.pollID).getContext("2d") ).Pie(data,json.options);
                            if (parseInt(json.showLegend))
                                legend(document.getElementById("legend-" + chart.options.pollID), data);
                            break;

                        case 3:

                            chart.options.display = new Chart( document.getElementById("weblator-charts-chart-" + chart.options.pollID).getContext("2d") ).Doughnut(data,json.options);
                            if (parseInt(json.showLegend))
                                legend(document.getElementById("legend-" + chart.options.pollID), data);
                            break;

                        case 4:

                            chart.options.display = new Chart( document.getElementById("weblator-charts-chart-" + chart.options.pollID).getContext("2d") ).Line(data,json.options);
                            break;

                        case 5:

                            chart.options.display = new Chart( document.getElementById("weblator-charts-chart-" + chart.options.pollID).getContext("2d") ).Radar(data,json.options);
                            break;

                        case 6:

                            chart.options.display = new Chart( document.getElementById("weblator-charts-chart-" + chart.options.pollID).getContext("2d") ).PolarArea(data,json.options);
                            if (parseInt(json.showLegend))
                                legend(document.getElementById("legend-" + chart.options.pollID), data);
                            break;

                        case 7:
                            createBootstrapChart(data, json.options, json.maxWidth, json.percentage);
                            break;
                    }


                });


        });


    }


    function overrideOptions(){




        if (chart.options.chartType != 5 || chart.options.chartType != 6){
            var min = Infinity, max = -Infinity, x;
            for( x in chart.options.chartTotals) {
                if( chart.options.chartTotals[x] < min) min = chart.options.chartTotals[x];
                if( chart.options.chartTotals[x] > max) max = chart.options.chartTotals[x];
            }

            var scaleSteps = 20;
            var scaleStepWidth = 1;
            var scaleStart = 0;

            if (max < 20){
                scaleSteps = max;

            }else {

                scaleStepWidth = Math.ceil(max/scaleSteps);
            }

            if (chart.options.chartType == 5 || chart.options.chartType == 6){
                scaleSteps = chart.options.chartOptionsCount;
                scaleStart = 0;
                scaleStepWidth = Math.ceil(max/scaleSteps);
            }

            var steps = new Number(max);
            var stepWidth = new Number(1);
            if (max > 10) {
                stepWidth = Math.floor(max / 10);
                steps = Math.ceil(max / stepWidth);
            }

            if (isIE(8)){

                return options = {

                    scaleOverride : true,
                    scaleSteps : steps,
                    scaleStepWidth : stepWidth,
                    scaleStartValue : scaleStart,
                    animation : false
                };

            }else {

                return options = {

                    scaleOverride : true,
                    scaleSteps : steps,
                    scaleStepWidth : stepWidth,
                    scaleStartValue : scaleStart
                };
            }


        }




    }

    function isIE(version, comparison) {
        var cc      = 'IE',
            b       = document.createElement('B'),
            docElem = document.documentElement,
            isIE;

        if(version){
            cc += ' ' + version;
            if(comparison){ cc = comparison + ' ' + cc; }
        }

        b.innerHTML = '<!--[if '+ cc +']><b id="iecctest"></b><![endif]-->';
        docElem.appendChild(b);
        isIE = !!document.getElementById('iecctest');
        docElem.removeChild(b);
        return isIE;
    }

    function createBootstrapChart(data, override, maxWidth, percentage){

        jQuery("#weblator-charts-chart-" + chart.options.pollID).remove();

        var total = 0;
        for(var i=0; i < data.length; i++)
            total = total + parseInt(data[i].value);



        var bsChartContainer = jQuery('<div/>')
            .attr("class", "bs-chart-container")
            .css("display", "none");


        for(var i = 0; i < data.length; i++){

            var label = jQuery("<strong/>").html(data[i].label);

            var progressContainer = jQuery('<div/>').attr("class", "progress");

            if (!parseInt(percentage))
                var p = (data[i].value / total) * 100
            else
                var p = data[i].value;

            var progressBar = jQuery('<div/>')
                .attr("class", "progress-bar")
                .attr("role", "progressbar")
                .attr("aria-valuenow", p)
                .attr("aria-valuemin", 0)
                .css({
                    backgroundColor : data[i].color
                });

            if (override.bsBarStriped)
                progressContainer.addClass("progress-striped");

            var span = jQuery('<span/>')
                .attr("class", "")
                .html(data[i].value);

            if (parseInt(percentage))
                span.append("%");

            if (p > 0)
                progressBar.append(span);

            progressContainer.append(progressBar);
            bsChartContainer.append(label);
            bsChartContainer.append(progressContainer);

        }

        jQuery("[data-chart-id='"+ chart.options.pollID +"']").after(bsChartContainer);

        bsChartContainer.slideDown();

        jQuery(".progress-bar").each(function(){

            var value = jQuery(this).attr("aria-valuenow");

            jQuery(this).animate({
                width:value + "%"
            }, 1000);

        });
    }

    init(id);
};
